Index: /gli/trunk/src/org/greenstone/gatherer/remote/RemoteGreenstoneServer.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/remote/RemoteGreenstoneServer.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/remote/RemoteGreenstoneServer.java	(revision 17612)
@@ -58,99 +58,114 @@
 public class RemoteGreenstoneServer
 {
+    // A PasswordAuthentication object is created whenever it is required
+    static private PasswordAuthentication remote_greenstone_server_authentication = null;
+    // static private PasswordAuthentication remote_greenstone_server_authentication = new PasswordAuthentication(System.getProperty("user.name"), new char[] { });
+
+    private ActionQueue remote_greenstone_server_action_queue;
+    private RemoteGreenstoneServer.ProgressBar progress_bar;
+
+    public RemoteGreenstoneServer() {
+	remote_greenstone_server_action_queue = new ActionQueue();
+	progress_bar = new RemoteGreenstoneServer.ProgressBar();
+    }
+
     // ----------------------------------------------------------------------------------------------------
     //   PUBLIC LAYER
     // ----------------------------------------------------------------------------------------------------
-
-
-    static public String deleteCollection(String collection_name)
-    {
-	return performAction(new RemoteGreenstoneServerDeleteCollectionAction(collection_name));
-    }
-
-
-    static public String deleteCollectionFile(String collection_name, File collection_file)
-    {
-	return performAction(new RemoteGreenstoneServerDeleteCollectionFileAction(collection_name, collection_file));
-    }
-
-
-    static public String downloadCollection(String collection_name)
-    {
-	return performAction(new RemoteGreenstoneServerDownloadCollectionAction(collection_name));
-    }
-
-
-    static public String downloadCollectionArchives(String collection_name)
-    {
-	return performAction(new RemoteGreenstoneServerDownloadCollectionArchivesAction(collection_name));
-    }
-
-
-    static public String downloadCollectionConfigurations()
-    {
-	return performAction(new RemoteGreenstoneServerDownloadCollectionConfigurationsAction());
-    }
-
-
-    static public String downloadCollectionFile(String collection_name, File collection_file)
-    {
-	return performAction(new RemoteGreenstoneServerDownloadCollectionFileAction(collection_name, collection_file));
+    public String deleteCollection(String collection_name)
+    {
+	return performAction(new RemoteGreenstoneServerAction.DeleteCollectionAction(collection_name));
+    }
+
+
+    public String deleteCollectionFile(String collection_name, File collection_file)
+    {
+	return performAction(new RemoteGreenstoneServerAction.DeleteCollectionFileAction(collection_name, collection_file));
+    }
+
+
+    public String downloadCollection(String collection_name)
+    {
+	return performAction(new RemoteGreenstoneServerAction.DownloadCollectionAction(collection_name));
+    }
+
+
+    public String downloadCollectionArchives(String collection_name)
+    {
+	return performAction(new RemoteGreenstoneServerAction.DownloadCollectionArchivesAction(collection_name));
+    }
+
+
+    public String downloadCollectionConfigurations()
+    {
+	return performAction(new RemoteGreenstoneServerAction.DownloadCollectionConfigurationsAction());
+    }
+
+
+    public String downloadCollectionFile(String collection_name, File collection_file)
+    {
+	return performAction(new RemoteGreenstoneServerAction.DownloadCollectionFileAction(collection_name, collection_file));
     }
     
     // get web.xml from the server -- for a remote gli of GS3
-    static public String downloadWebXMLFile()
-    {
-	return performAction(new RemoteGreenstoneServerDownloadWebXMLFileAction());
-    }
-
-    static public String getScriptOptions(String script_name, String script_arguments)
-    {
-	return performAction(new RemoteGreenstoneServerGetScriptOptionsAction(script_name, script_arguments));
+    public String downloadWebXMLFile()
+    {
+	return performAction(new RemoteGreenstoneServerAction.DownloadWebXMLFileAction());
+    }
+
+    public String getScriptOptions(String script_name, String script_arguments)
+    {
+	return performAction(new RemoteGreenstoneServerAction.GetScriptOptionsAction(script_name, script_arguments));
     }
     
     //get all available site names from the server -- for a remote gli of GS3
-    static public String getSiteNames()
-    {
-	return performAction(new RemoteGreenstoneServerGetSiteNamesAction());
-    }
-
-    static public String moveCollectionFile(String collection_name, File source_collection_file, File target_collection_file)
-    {
-	return performAction(new RemoteGreenstoneServerMoveCollectionFileAction(collection_name, source_collection_file, target_collection_file));
-    }
-
-
-    static public String newCollectionDirectory(String collection_name, File new_collection_directory)
-    {
-	return performAction(new RemoteGreenstoneServerNewCollectionDirectoryAction(collection_name, new_collection_directory));
-    }
-
-
-    static public String runScript(String collection_name, String script_name, String script_arguments, GShell shell)
-    {
-	return performAction(new RemoteGreenstoneServerRunScriptAction(collection_name, script_name, script_arguments, shell));
-    }
-
-
-    static public String uploadCollectionFile(String collection_name, File collection_file)
-    {
-	return performAction(new RemoteGreenstoneServerUploadCollectionFilesAction(collection_name, new File[] { collection_file }));
-    }
-
-
-    static public String uploadCollectionFiles(String collection_name, File[] collection_files)
-    {
-	return performAction(new RemoteGreenstoneServerUploadCollectionFilesAction(collection_name, collection_files));
-    }
-
-
-    static public String uploadFilesIntoCollection(String collection_name, File[] source_files, File target_collection_directory)
-    {
-	return performAction(new RemoteGreenstoneServerUploadFilesIntoCollectionAction(collection_name, source_files, target_collection_directory));
-    }
-
-    static public boolean exists(String collection_name, File collection_file)
-    {
-	String result = performAction(new RemoteGreenstoneServerExistsAction(collection_name, collection_file));
+    public String getSiteNames()
+    {
+	return performAction(new RemoteGreenstoneServerAction.GetSiteNamesAction());
+    }
+
+    public String moveCollectionFile(String collection_name, File source_collection_file, File target_collection_file)
+    {
+	return performAction(new RemoteGreenstoneServerAction.MoveCollectionFileAction(
+                             collection_name, source_collection_file, target_collection_file));
+    }
+
+
+    public String newCollectionDirectory(String collection_name, File new_collection_directory)
+    {
+	return performAction(new RemoteGreenstoneServerAction.NewCollectionDirectoryAction(
+                             collection_name, new_collection_directory));
+    }
+
+
+    public String runScript(String collection_name, String script_name, String script_arguments, GShell shell)
+    {
+	return performAction(new RemoteGreenstoneServerAction.RunScriptAction(
+                             collection_name, script_name, script_arguments, shell));
+    }
+
+
+    public String uploadCollectionFile(String collection_name, File collection_file)
+    {
+	return performAction(new RemoteGreenstoneServerAction.UploadCollectionFilesAction(
+                             collection_name, new File[] { collection_file }));
+    }
+
+
+    public String uploadCollectionFiles(String collection_name, File[] collection_files)
+    {
+	return performAction(new RemoteGreenstoneServerAction.UploadCollectionFilesAction(collection_name, collection_files));
+    }
+
+
+    public String uploadFilesIntoCollection(String collection_name, File[] source_files, File target_collection_directory)
+    {
+	return performAction(new RemoteGreenstoneServerAction.UploadFilesIntoCollectionAction(
+                             collection_name, source_files, target_collection_directory));
+    }
+
+    public boolean exists(String collection_name, File collection_file)
+    {
+	String result = performAction(new RemoteGreenstoneServerAction.ExistsAction(collection_name, collection_file));
 	if(result.indexOf("exists") != -1) {
 	    return true;
@@ -162,8 +177,8 @@
     }
 
-    static public int getGreenstoneVersion()
+    public int getGreenstoneVersion()
     {
 	// returns message "Greenstone version is: <version number of the Greenstone remote server>"
-	String result = performAction(new RemoteGreenstoneServerVersionAction());
+	String result = performAction(new RemoteGreenstoneServerAction.VersionAction());
 	int index = result.indexOf(":"); 
 	if(index != -1) {
@@ -175,8 +190,8 @@
 
     /** For constructing the preview command (the library URL) with */
-    static public String getLibraryURL(String serverHomeURL)
+    public String getLibraryURL(String serverHomeURL)
     {
 	// returns message "Greenstone library URL suffix is: <e.g. /greenstone3/library or /gsdl/cgi-bin/library>"
-	String libSuffix = performAction(new RemoteGreenstoneServerLibraryURLSuffixAction());
+	String libSuffix = performAction(new RemoteGreenstoneServerAction.LibraryURLSuffixAction());
 	int index = libSuffix.indexOf(":"); 
 	if(index != -1) {
@@ -200,5 +215,5 @@
 
 
-    static public void exit()
+    public void exit()
     {
 	System.err.println("Exiting, number of jobs on queue: " + remote_greenstone_server_action_queue.size());
@@ -223,5 +238,5 @@
 
     /** Returns null if we cannot wait for the action to finish, "" if the action failed, or the action output. */
-    static private String performAction(RemoteGreenstoneServerAction remote_greenstone_server_action)
+    private String performAction(RemoteGreenstoneServerAction remote_greenstone_server_action)
     {
 	// Add the action to the queue
@@ -255,122 +270,12 @@
 
 
-    static private RemoteGreenstoneServerActionQueue remote_greenstone_server_action_queue = new RemoteGreenstoneServerActionQueue();
-
-
-    static private class RemoteGreenstoneServerActionQueue
-	extends Thread
-    {
-	/** The queue of waiting jobs. */
-	private ArrayList queue = null;
-
-
-	public RemoteGreenstoneServerActionQueue()
-	{
-	    if (Gatherer.isGsdlRemote) {
-		queue = new ArrayList();
-		start();
-	    }
-	}
-
-
-	synchronized public void addAction(RemoteGreenstoneServerAction remote_greenstone_server_action)
-	{
-	    queue.add(remote_greenstone_server_action);
-	    notifyAll();
-	}
-
-
-	public int size()
-	{
-	    return queue.size();
-	}
-
-
-	public void run()
-	{
-	    boolean exit = false;
-	    while (true) {
-		// If there are jobs on the queue, get the next in line and process it
-		if (queue.size() > 0) {
-		    RemoteGreenstoneServerAction remote_greenstone_server_action = (RemoteGreenstoneServerAction) queue.get(0);
-
-		    try {
-			remote_greenstone_server_action.perform();
-			
-			// No exceptions were thrown, so the action was successful
-			remote_greenstone_server_action.processed_successfully = true;
-		    }
-		    catch (RemoteGreenstoneServerActionCancelledException exception) {
-			remote_greenstone_server_action.processed_successfully = false;
-			exit = true;
-		    } 
-		    catch(java.net.ConnectException exception) {
-			if(exception.getMessage().trim().startsWith("Connection refused")) {
-			    exit = true;
-			} else {
-			    DebugStream.printStackTrace(exception);
-			}
-			JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("RemoteGreenstoneServer.Error", exception.getMessage()), Dictionary.get("RemoteGreenstoneServer.Error_Title"), JOptionPane.ERROR_MESSAGE);
-			remote_greenstone_server_action.processed_successfully = false;			
-		    }
-		    catch (FileNotFoundException exception) {
-			// FileNotFoundException happens when there's no GS server at the user-provided
-			// url (the address of gliserver.pl is wrong).
-			exit = true;
-			DebugStream.printStackTrace(exception);
-			JOptionPane.showMessageDialog(Gatherer.g_man, 
-						      Dictionary.get("RemoteGreenstoneServer.Error", 
-								     "No gliserver.pl found. " + exception.getMessage()), 
-						      Dictionary.get("RemoteGreenstoneServer.Error_Title"), 
-						      JOptionPane.ERROR_MESSAGE);
-			remote_greenstone_server_action.processed_successfully = false;
-		    }
-		    catch (Exception exception) {
-			DebugStream.printStackTrace(exception);
-			JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("RemoteGreenstoneServer.Error", exception.getMessage()), Dictionary.get("RemoteGreenstoneServer.Error_Title"), JOptionPane.ERROR_MESSAGE);
-			remote_greenstone_server_action.processed_successfully = false;
-		    }
-
-		    // We're done with this action, for better or worse
-		    remote_greenstone_server_action.processed = true;
-		    queue.remove(0);
-		}
-
-		// Otherwise the queue is empty
-		else {
-		    progress_bar.setAction(null);
-
-		    // Wait until we are notify()ed by addAction that there is a new job on the queue
-		    synchronized (this) {
-			try {
-			    wait();
-			}
-			catch (InterruptedException exception) { }
-		    }
-		}
-		
-		// stop the gazillion annoying error messages when the connection was simply
-		// refused or when the user pressed Cancel in the opening dialog, by exitting
-		// cleanly in one go.
-		if(exit == true) {
-		    Gatherer.exit();
-		}
-	    }
-	}
-    }
-
-
     // ----------------------------------------------------------------------------------------------------
     //   PROGRESS BAR
     // ----------------------------------------------------------------------------------------------------
 
-
-    static private RemoteGreenstoneServerProgressBar progress_bar = new RemoteGreenstoneServerProgressBar();
-
-
-    static private class RemoteGreenstoneServerProgressBar
+    static class ProgressBar
 	extends JProgressBar
     {
-	public RemoteGreenstoneServerProgressBar()
+	public ProgressBar()
 	{
 	    setBackground(Configuration.getColor("coloring.collection_tree_background", false));
@@ -404,7 +309,6 @@
 	}
     }
-
-
-    static public RemoteGreenstoneServerProgressBar getProgressBar()
+    
+    public RemoteGreenstoneServer.ProgressBar getProgressBar()
     {
 	return progress_bar;
